std::is_standard_layout(3)

NAME
std::is_standard_layout - std::is_standard_layout

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_standard_layout;
   If T is a standard-layout type, provides the member constant value equal to true.
   For any other type, value is false.
   The behavior is undefined if std::remove_all_extents_t<T> is an incomplete type and
   not (possibly cv-qualified) void.
   The behavior of a program that adds specializations for is_standard_layout
   or is_standard_layout_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T >
   inline constexpr bool is_standard_layout_v = (since C++17)
   is_standard_layout<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a standard-layout type , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Notes
   A pointer to a standard-layout class may be converted (with reinterpret_cast) to a
   pointer to its first non-static data member and vice versa.
   If a standard-layout union holds two or more standard-layout structs, it is
   permitted to inspect the common initial part of them.
   The macro offsetof is only guaranteed to be usable with standard-layout classes.

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 struct A
 {
     int m;
 };
 struct B
 {
     int m1;
 private:
     int m2;
 };
 struct C
 {
     virtual void foo();
 };
 int main()
 {
     std::cout << std::boolalpha;
     std::cout << std::is_standard_layout<A>::value << '\n';
     std::cout << std::is_standard_layout<B>::value << '\n';
     std::cout << std::is_standard_layout<C>::value << '\n';
 }

Output:
 true
 false
 false

See also
   is_trivially_copyable checks if a type is trivially copyable
   (C++11) (class template)
   is_pod checks if a type is a plain-old data (POD) type
   (C++11)(deprecated in C++20) (class template)
                        byte offset from the beginning of a standard-layout
   offsetof type to specified member
                        (function macro)